jQuery(document).ready(function(){
	var $ = jQuery;
	
	$('.test-connection').click(function(){
		$('.connection-message-overlay').fadeIn(400);
		$('.loader').fadeIn(200);
		var ajax = $('#ajax').val();
		action = "test_braintree_connection";
		if(this.value == 'production'){
			var merchantId = $('#braintree_production_merchantId').val();
			var publicKey = $('#braintree_production_public_key').val();
			var privateKey = $('#braintree_production_private_key').val();
			var environment = 'production';
		}
		else if (this.value == 'sandbox') {
			var merchantId = $('#braintree_sandbox_merchantId').val();
			var publicKey = $('#braintree_sandbox_public_key').val();
			var privateKey = $('#braintree_sandbox_private_key').val();
			var environment = 'sandbox';
		}
		var data = {action: action, merchantId: merchantId, 
				publicKey: publicKey, privateKey: privateKey, environment: environment}
		
		$.ajax({
			
			url: ajax,
			data: data,
			dataType: 'json', 
			type: 'POST', 
			success: function(response){
				if(response){
					if(response.code == "success"){
				$('#connection-messages').append('<p class="connection-message">'+response.message+'</p>');
				$('#connection-messages').addClass('is-success');
				$('#connection-messages').fadeIn(400);
				$('.connection-message-overlay').fadeIn(400);
				$('.loader').fadeOut(200);
					}
					else if (response.code == "error"){
						$('#connection-messages').append('<p class="connection-message">' + response.message + '</p>');
						$('#connection-messages').addClass('is-failure');
						$('#connection-messages').fadeIn(400);
						$('.connection-message-overlay').fadeIn(400);
					}
				}
			},
			error: function(jqXHR, textStatus, errorThrown){
				$('#connection-messages').append('<p class="connection-message">'+errorThrown + ': Connection could not be made. Please check your configuration</p>');
				$('#connection-messages').addClass('is-success');
				$('.connection-message-overlay').fadeIn(400);
			}
		
		})
		return false;
	})
	
	$('.close-icon').click(function(){
		$('#connection-messages .connection-message').remove();
		$('#connection-messages').removeClass('is-success');
		$('#connection-messages').removeClass('is-failure');
		$('.connection-message-overlay').fadeOut(400);
		$('#connection-messages').fadeOut(400);

	})
	
	$('#paypal_enabled').on('click', function(){
		if($('#paypal_enabled').is(':checked')){
		var img = $('#custom-paypal').val();
		$('#custom-ui-img').attr('src', img);
		}
		else{
			var img = $('#custom-ui').val();
			$('#custom-ui-img').attr('src', img);
		}
		
		
	})
	
})
