jQuery(document).ready(function(){
	
	var $ = jQuery;
	$('#donate-button').on('click', function(){
		$('.braintree-donations').fadeIn(400);
		$('.donations-overlay').fadeIn(400);
		
	})
	
	$('.close-donation').on('click', function(){
		$('.braintree-donations').fadeOut(400);
		$('.donations-overlay').fadeOut(400);
	})
	
	function process_braintree_paypal_donation(obj){
		$('.loader').fadeIn(200);
		var ajax_url = $('#ajax_url').val();
		var donation_amount = $('#donation_amount').val();
		var billing_name = $('#billing_name').val();
		var data;
		data = {action: 'braintree_process_donation_payment', donation_amount: donation_amount, 
				payment_method_nonce: obj.nonce, payment_type: obj.type,
				paypalEmail: obj.email, billing_name: obj.firstName + obj.lastName};
		if($('#donation_firstname').length && $('#donation_firstname' != undefined)){
			var donation_firstname = $('#donation_firstname').val();
			data['donation_firstname'] = donation_firstname;
		}
		if($('#donation_lastname').length && $('#donation_lastname' != undefined)){
			var donation_lastname = $('#donation_lastname').val();
			data['donation_lastname'] = donation_lastname;
		}
		$('.braintree-donations').fadeOut(400);
	$.ajax({
			
			type: 'POST', 
			url: ajax_url,
			dataType: 'html', 
			data: data,
			success: function(response){
			$('.loader').fadeOut(200);
			$('#donation-message').html(response);
			$('.braintree-donations-message').fadeIn(400);
			$('.braintree-donations').fadeOut(400);
			
			$('.close-icon-success').on('click', function(){
				$('.donations-overlay').fadeOut(400);
				$('.braintree-donations-message').fadeOut(400);
			})
			
				$('.close-icon-failure').on('click', function(){
				$('.donations-overlay').fadeOut(400);
				$('.braintree-donations-message').fadeOut(400);
			})
			
			}, 
			error: function(){
				$('.loader').fadeOut(200);
			}
			
		})
	}
	
	function process_braintree_donation(response){
		if($('#form_style').val() === 'modal'){
		$('.loader').fadeIn(200);
		}
		else {
			$('.donations-overlay').fadeIn(400);
		}
		var ajax_url = $('#ajax_url').val();
		//var payment_method_nonce = $('payment_method_nonce').val();
		var donation_amount = $('#donation_amount').val();
		var billing_name = $('#billing_name').val();
		var billing_address = $('#billing_address').val();
		var postal_code = $('#billing_postalcode').val();
		var billing_country = $('#billing_country').val();
		if(response.type === 'CreditCard'){
			data = {action: 'braintree_process_donation_payment', donation_amount: donation_amount, 
				payment_method_nonce: response.nonce, payment_type: response.type, cardType: response.details.cardType,
				cardId: response.details.lastTwo, billing_name: billing_name,
				billing_address: billing_address, billing_postalcode: postal_code, billing_country: billing_country};
		}
		if(response.type === 'PayPalAccount' || (typeof response.details.email != 'undefined')){
			data = {action: 'braintree_process_donation_payment', donation_amount: donation_amount, 
				payment_method_nonce: response.nonce, payment_type: response.type,
				paypalEmail: response.details.email, billing_name: billing_name, 
				billing_address: billing_address, billing_postalcode: postal_code};
		}
		if($('#donation_firstname').length && $('#donation_firstname' != undefined)){
			var donation_firstname = $('#donation_firstname').val();
			data['donation_firstname'] = donation_firstname;
		}
		if($('#donation_lastname').length && $('#donation_lastname' != undefined)){
			var donation_lastname = $('#donation_lastname').val();
			data['donation_lastname'] = donation_lastname;
		}
		$('.braintree-donations').fadeOut(400);
		$.ajax({
			
			type: 'POST', 
			url: ajax_url,
			dataType: 'html', 
			data: data,
			success: function(response){
			$('.loader').fadeOut(200);
			$('#donation-message').html(response);
			$('.braintree-donations-message').fadeIn(400);
			$('.braintree-donations').fadeOut(400);
			
			$('.close-icon-success').on('click', function(){
				$('.donations-overlay').fadeOut(400);
				$('.braintree-donations-message').fadeOut(400);
			})
			
				$('.close-icon-failure').on('click', function(){
				$('.donations-overlay').fadeOut(400);
				$('.braintree-donations-message').fadeOut(400);
			})
			
			}, 
			error: function(){
				$('.loader').fadeOut(200);
			}
			
		})
		return ;
	}
	
	function setup_braintree_paypal(){
		var client_token = $('#client_token').val();
		var container = '';
		if($('#paypal_active').length) {
			braintree.setup(client_token, "paypal", {container: "paypal-container", 
				onPaymentMethodReceived: function(obj){
					if(obj){
						process_braintree_paypal_donation(obj);
					}
				}});
		}
	}
	
	function setup_braintree_creditCard(){
		var client_token = $('#client_token').val();
		braintree.setup(client_token, "custom", {id: "braintree_donations_form",
			onPaymentMethodReceived: function(response){
				if(response){
					process_braintree_donation(response)
						
				}
			},
			onReady: function(integration){
				checkout = integration;
			},
			onError: function(response){
				if(response.type === "CONFIGURATION"){
					var html = '<div class="response-message"><span>'+ response.message +'</span></div>';
					document.getElementById('braintree_donations_form').appendChild(html);
				}
				else if(response.type === "VALIDATION"){
					var html = '<div class="response-message"><span>'+ response.message +'<span></div>';
					document.getElementById('braintree_donations_form').appendChild(html);
				}
			}})
		}
	
	function setup_dropin_ui(){
		var client_token = $('#client_token').val();
				braintree.setup(client_token, "dropin", {container: "dropin_container",
					onPaymentMethodReceived: function(response){
						if(response){
							process_braintree_donation(response)
								
						}
					},
					onReady: function(integration){
						checkout = integration;
					},
					onError: function(response){
						if(response.type === "CONFIGURATION"){
							var html = '<div class="response-message"><span>'+ response.message +'</span></div>';
							document.getElementById('braintree_donations_form').appendChild(html);
						}
						else if(response.type === "VALIDATION"){
							var html = '<div class="response-message"><span>'+ response.message +'<span></div>';
							document.getElementById('braintree_donations_form').appendChild(html);
						}
					}})
			
	}
	
			
	var checkout;
	
	if($('input[name="braintree-donation-paymentMethod"]').length){
	$('input[name="braintree-donation-paymentMethod"]').on('change', function(e){
		if($(this).val() == 'creditCard'){
			$('#creditcard-donation-container').slideDown(400);
			$('#paypal-donation-container').slideUp(400);
			var client_token = $('#client_token').val();
			//teardown the integration if the radio button has been selected already. This code prevents
			//multiple nonces from being submited to the server. 
			if(checkout){
				checkout.teardown(function(){
					checkout = null;
				})
			}
			setup_braintree_creditCard();
		}
		else {
			$('#creditcard-donation-container').slideUp(400);
			$('#paypal-donation-container').slideDown(400);
			$('#paypal-container').html('');
			if(checkout){
				checkout.teardown(function(){
					checkout = null;
				})
			}
			setup_braintree_paypal();
		}
	})
	} 
	else {
		if($('#dropin-container').length){
			setup_dropin_ui();
		}
	};
		
	
	$('#braintree-paypal-button').on('click', function(){
		$('#num_num').prop('disabled', true);
		$('#cvv').prop('disabled', true);
		$('#exp').prop('disabled', true);
		$('#cancel-paypal').fadeIn(300);
	})
	$('#cancel-paypal').on('click', function(){
		$('#num_num').prop('disabled', false);
		$('#cvv').prop('disabled', false);
		$('#exp').prop('disabled', false);
		
	})
	
})