<?php
/*Plugin Name: Braintree For Woocommerce
 Plugin URI: www.paymentplugins.com
 Description: Accept credit card and paypal payments or donations on your wordpress site using your Braintree merchant account. SAQ A & SAQ A-EP compliant. 
 Version: 2.2.05
 Author: Clayton Rogers, mr.clayton@paymentplugins.com
 Author URI:
 Tested up to: 4.3.1
 */
if(PHP_VERSION < 5.4){
	$message = sprintf('Your PHP Version is %s but Braintree requires PHP Version 5.4 or greater. Please update
				your PHP Version to activate this plugin.', PHP_VERSION);
	echo '<div class="error"><p>'.$message.'</p></div>';
	exit();
}

define('BRAINTREE_PAYMENTS_LOC', plugin_dir_path(__FILE__));
define('BRAINTREE_PAYMENTS_ASSETS', plugin_dir_url(__FILE__).'assets/' );
define('BRAINTREE_PAYMENTS_ADMIN', plugin_dir_url(__FILE__).'admin/');
define('BRAINTREE_LICENSE_ACTIVATION_URL', 'http://paymentplugins.com/');
define('BRAINTREE_LICENSE_VERIFICATION_KEY', 'gTys$hsjeScg63dDs35JlWqbx7h');

if(! class_exists('Braintree_Base')){
require_once(BRAINTREE_PAYMENTS_LOC.'Braintree.php');
}
require_once(BRAINTREE_PAYMENTS_LOC.'includes/Classes/Braintree_Donations.php');
require_once(BRAINTREE_PAYMENTS_LOC.'includes/Classes/BraintreeAddressException.php');
require_once(BRAINTREE_PAYMENTS_LOC.'includes/Classes/BraintreeDonationException.php');
require_once(BRAINTREE_PAYMENTS_LOC.'includes/Classes/BraintreeTransactionLog.php');
require_once(BRAINTREE_PAYMENTS_LOC.'woopayment-gateway/braintree-payment-gateway.php');

require_once(BRAINTREE_PAYMENTS_LOC.'admin/admin-functions.php');
require_once(BRAINTREE_PAYMENTS_LOC.'admin/braintree-admin-functions.php');
require_once(BRAINTREE_PAYMENTS_LOC.'admin/class-braintree-manager.php');
require_once(BRAINTREE_PAYMENTS_LOC.'includes/braintree-donations-functions.php');
require_once(BRAINTREE_PAYMENTS_LOC.'includes/Classes/Braintree-Currencies.php');
require_once(BRAINTREE_PAYMENTS_LOC.'includes/Classes/Donation-Countries.php');
require_once(BRAINTREE_PAYMENTS_LOC.'includes/Classes/BraintreePaymentMethods.php');

function create_braintree_log_directory(){
	$file = WP_CONTENT_DIR.'/braintree/logs/transaction-log.txt';
	$dir = WP_CONTENT_DIR.'/braintree/logs';
	if(file_exists($file)){
		return false;
	}
	else {
		wp_mkdir_p($dir);
	}
}

register_activation_hook(__FILE__, 'create_braintree_log_directory');
register_activation_hook(__FILE__, 'BT_Manager::versionUpdater');

