jQuery(document).ready(function ($) {

    $('.backend-product-options').on('change', '.allow-multiple-options', function () {
        $(this).closest('.backend-product-option').find('.maximum-and-minimum').toggle();
    });

    $('.allow-multiple-options:checked').each(function () {
        $(this).closest('.backend-product-option').find('.maximum-and-minimum').show();
    });

    function updateDefaults(defaultCheckbox) {
        if (defaultCheckbox.is(':checked')) {
            defaultCheckbox.closest('.backend-product-option').find('.default-column').hide();
        } else {
            defaultCheckbox.closest('.backend-product-option').find('.default-column').show();
        }
    }

    $('.backend-product-options').on('click', '.backend-no-default-checkbox', function (event) {
        updateDefaults($(this));
    });
    $('.backend-no-default-checkbox').each(function () {
        updateDefaults($(this));
    });

    var file_frame;
    var element_clicked;
    $('.backend-product-options').on('click', '.backend-upload-image-button', function (event) {
        event.preventDefault();
        element_clicked = $(this);
        // If the media frame already exists, reopen it.
        if (file_frame) {
            file_frame.open();
            return;
        }

        // Create the media frame.
        file_frame = wp.media.frames.file_frame = wp.media({
            title: jQuery(this).data('uploader_title'),
            button: {
                text: jQuery(this).data('uploader_button_text'),
            },
            multiple: false  // Set to true to allow multiple files to be selected
        });

        // When an image is selected, run a callback.
        file_frame.on('select', function () {
            // We set multiple to false so only get one image from the uploader
            attachment = file_frame.state().get('selection').first().toJSON();
            var optionForImage = element_clicked.closest('.backend-upload-image');
            optionForImage.find('.backend-upload-image-src').val(attachment.url);
            optionForImage.find('.backend-image-upload').attr('src', attachment.url);
        });

        // Finally, open the modal
        file_frame.open();
    });

    $('.backend-product-options').on('click', '.backend-product-option h2', function () {
        $(this).closest('.backend-product-option').find('.backend-product-option-toggle').toggle(500);
        var expandHideText = $(this).closest('.backend-product-option').find('.backend-expand-hide');
        expandHideText.text(expandHideText.text() == '+' ? '-' : '+');
    });

    $('#product-options-form').submit(function (event) {
        event.preventDefault();
    });

    $('.backend-product-options').on('change', 'input, select, textarea', function () {
        ajax_option_chosen($(this));
    });

    $('.backend-product-options').find('.backend-product-option-id').each(function () {
        ajax_option_chosen($(this));
    });

    function ajax_option_chosen(optionChanged) {
        if (optionChanged.closest('.backend-product-option').parent().closest('.backend-product-option').length > 0) {
            return;
        }
        var productOption = optionChanged.closest('.backend-product-option');
        var productOptionId = productOption.closest('.backend-product-option').find('.backend-product-option-id').val();
        var optionsChosen = {};
        productOption.find('.backend-outside-preview').find('input, select, textarea').each(function () {
            if ($(this).attr('name') != undefined) {
                var name = $(this).attr('name');
                if (name.indexOf('[options]') >= 0) {
                    var splitOption = name.split('[options]');
                    if (splitOption.length == 2) {
                        var productOption = splitOption[0];
                        var option = splitOption[1];
                        var optionId = $(this).closest('.backend-option').find('.backend-option-id').val();
                        var optionName = option.replace('[' + optionId + '][', '').replace(']', '');
                        if (optionsChosen[productOptionId] == undefined) {
                            optionsChosen[productOptionId] = {};
                        }
                        if (optionsChosen[productOptionId]['options'] == undefined) {
                            optionsChosen[productOptionId]['options'] = {};
                        }
                        if (optionsChosen[productOptionId]['options'][optionId] == undefined) {
                            optionsChosen[productOptionId]['options'][optionId] = {};
                        }
                        var value = $(this).val();
                        if ($(this).attr('type') == 'radio') {
                            value = $('input[name="' + $(this).attr('name') + '"]:checked').val();
                        }
                        optionsChosen[productOptionId]['options'][optionId][optionName] = value;
                    }
                } else {
                    var optionName = name.replace('backend-product-options[' + productOptionId + '][', '').replace(']', '');
                    if (optionsChosen[productOptionId] == undefined) {
                        optionsChosen[productOptionId] = {};
                    }
                    var value = $(this).val();
                    if ($(this).attr('type') == 'radio') {
                        value = $('input[name="' + $(this).attr('name') + '"]:checked').val();
                    }
                    optionsChosen[productOptionId][optionName] = value;
                }
            }
        });
        var preview = productOption.find('.backend-product-option-preview');
        preview.css('opacity', '0.5');
        $.post(ajaxurl, {action: 'get_product_option_preview', options_chosen: optionsChosen}, function (response) {
            preview.html(response);
            preview.css('opacity', '1');
        });
    }

    $('.backend-product-option-toggle').hide();
    $('.backend-expand-hide').text('+')

    $('.backend-product-options').on('keyup', '.backend-product-option-title', function () {
        $(this).closest('.backend-product-option').find('.backend-option-title').text($(this).val());
    });

    $('#option-draggable div').draggable({
        appendTo: "body",
        helper: "clone"
    });

    $("#options-droppable").droppable({
        activeClass: "ui-state-default",
        hoverClass: "ui-state-hover",
        accept: ":not(.ui-sortable-helper)",
        drop: function (event, ui) {
            var type = ui.draggable.find('.backend-widget-type').val();
            var htmlForType = woocommerce_product_options_backend_settings[type];
            var maxId = 0;
            $(this).find('.backend-product-option-id').each(function () {
                if (parseInt($(this).val()) > parseInt(maxId)) {
                    maxId = $(this).val();
                }
            });
            maxId = parseInt(maxId) + 1;
            htmlForType = htmlForType.replace(new RegExp("product_option_id", "g"), maxId);
            $(this).append(htmlForType);
            $(this).find(".backend-placeholder").remove();
            hideOptions();
        }
    }).sortable({
        items: ".backend-product-option",
        cancel: ".backend-expand-hide, input, select, textarea, label",
        sort: function () {
            $(this).removeClass("ui-state-default");
        }
    });

    $('.backend-product-options').on('click', '.backend-add-new-option', function (event) {
        event.preventDefault();
        var options = $(this).closest('.backend-product-option').find('.backend-options');
        options.show();
        var maxId = 0;
        options.find('.backend-option-id').each(function () {
            if (parseInt($(this).val()) > parseInt(maxId))
                maxId = $(this).val();
        });
        maxId = parseInt(maxId) + 1;
        var productOption = $(this).closest('.backend-product-option');
        var productOptionId = productOption.find('.backend-product-option-id').val();
        var newOption = woocommerce_product_options_backend_settings['input_option']
                .replace(new RegExp("product_option_id", "g"), productOptionId)
                .replace(new RegExp("option_id", "g"), maxId);
        options.append(newOption);
        options.find('.backend-option-' + maxId).hide(0);
        options.find('.backend-option-' + maxId).show(500);
        updateDefaultOption($(this));
        ajax_option_chosen($(this));
    });


    $('.backend-product-options').on('click', '.backend-add-new-image-option', function (event) {
        event.preventDefault();
        var options = $(this).closest('.backend-product-option').find('.backend-options');
        options.show();
        var maxId = 0;
        options.find('.backend-option-id').each(function () {
            if (parseInt($(this).val()) > parseInt(maxId))
                maxId = $(this).val();
        });
        maxId = parseInt(maxId) + 1;
        var productOption = $(this).closest('.backend-product-option');
        var productOptionId = productOption.find('.backend-product-option-id').val();
        var newOption = woocommerce_product_options_backend_settings['image_input_option']
                .replace(new RegExp("product_option_id", "g"), productOptionId)
                .replace(new RegExp("option_id", "g"), maxId);
        options.append(newOption);
        options.find('.backend-option-' + maxId).hide(0);
        options.find('.backend-option-' + maxId).show(500);
        updateDefaultOption($(this));
        ajax_option_chosen($(this));
    });

    $('.backend-product-options').on('click', '.backend-remove-option', function (event) {
        event.preventDefault();
        var rowToRemove = $(this).closest('.backend-option');
        rowToRemove.addClass('backend-remove-this-row');
        rowToRemove.hide(500);
        var element = $(this).closest('.backend-product-option').find('.backend-product-option-id');
        setTimeout(function () {
            $('.backend-remove-this-row').remove();
            updateDefaultOption(element);
            ajax_option_chosen(element);
        }, 500);
    });

    $('.backend-product-options').on('click', '.backend-remove-product-option', function (event) {
        event.preventDefault();
        var rowToRemove = $(this).closest('.backend-product-option');
        rowToRemove.addClass('backend-remove-this-row');
        rowToRemove.hide(500);
        var element = $(this).closest('.backend-product-option').find('.backend-product-option-id');
        setTimeout(function () {
            $('.backend-remove-this-row').remove();
            updateDefaultOption(element);
            ajax_option_chosen(element);
        }, 500);
    });

    function updateDefaultOption(element) {
        if (element.closest('.backend-product-option').find('.backend-option-default:checked').length == 0) {
            element.closest('.backend-product-option').find('.backend-option-default').first().attr('checked', 'checked');
        }
    }


    function hideOptions() {
        $('.backend-options').each(function () {
            if ($(this).find('tr').length == 1) {
                $(this).hide();
            }
        });
    }

    $('.default-color-picker').wpColorPicker();

});