jQuery(document).ready(function ($) {

    if ($('.product-option').length > 0) {

        function updateMessage(productOption) {
            productOption.find('.product-option-appended-message').hide();
            // setTimeout(function() {
            productOption.find('.product-option-appended-message').remove();
            var message = '';
            productOption.find('input:checked').each(function () {
                var messageElement = $(this).closest('label').find('.product-option-message');
                if (messageElement.length > 0) {
                    message = message + '<div class="product-option-appended-message">' + messageElement.html() + '</div>';
                }
            });
            productOption.find('option:selected').each(function () {
                var messageElement = productOption.find('.product-option-message-' + $(this).val());
                if (messageElement.length > 0) {
                    message = message + '<div class="product-option-appended-message">' + messageElement.html() + '</div>';
                }
            });
            if (message.length > 0) {
                productOption.append(message);
            }
            productOption.find('.product-option-appended-message').show();
            //}, 500);
        }

        function ajax_update_option(optionChanged) {
//Disable cart button and options
            $('form.cart button').prop("disabled", true);
            $('form.cart button').css('opacity', '0.5');
            $('.product-option, .variations').find('input, select, textarea').prop("disabled", true);
            $('.product-option').find('input, select, textarea').css('opacity', '0.5');
			$('.product-option').find('input, select, textarea').css('opacity', '0.5');
			$('.variations').find('.value, .product_value, .product-value').css('opacity', '0.5'); 
            //Accordion
            var productOptions = optionChanged.closest('.product-options');
            if (productOptions.length > 0 && productOptions.find('.accordion-keep-open-on-select').val() == '' && productOptions.find('.accordion-expand').length > 0) {
                optionChanged.closest('.product-option').find('.product-option-accordion-content').hide(500);
                optionChanged.closest('.product-option').find('.accordion-expand').html('+');
            }
//Price
            var summary = optionChanged.closest('.summary, .main-data, .product-info, li.product');
            var amountToUpdate = summary.find('.price');
            if (summary.find('.variations').length > 0) {
                amountToUpdate = summary.find('.single-variation, .single_variation');
            }
            if (amountToUpdate.length == 0) {
                if ($('.price').length == 1) {
                    amountToUpdate = $('.price');
                }
            }
            var optionPriceToUpdate = optionChanged.closest('.product-option').find('.current-price');
            var productOption = optionChanged.val();
            if (optionChanged.closest('.product-option').find('input[type=checkbox].radio-image-radio').length > 0) {
                productOption = [];
                optionChanged.closest('.product-option').find('input[type=checkbox]:checked.radio-image-radio').each(function () {
                    productOption.push($(this).val());
                });
            }
            if (optionChanged.closest('.product-option').find('input[type=checkbox].product-option-checkbox').length > 0) {
                productOption = '';
                if (optionChanged.closest('.product-option').find('input[type=checkbox].product-option-checkbox:checked').length > 0) {
                    productOption = 'yes';
                }
            }
            var checkboxes = optionChanged.closest('.product-option').find('.checkboxes-checkbox');
            if (checkboxes.length > 0) {
                productOption = [];
                var optionId = optionChanged.closest('.product-option').find('.product-option-id').val();
                optionChanged.closest('.product-option').find('.checkboxes-checkbox:checked').each(function () {
                    productOption.push($(this).attr('name').replace('product-options[' + optionId + '][', '').replace(']', ''));
                });
            }
            var radioImageCheckboxes = optionChanged.closest('.product-option').find('.radio-image-radio[type=checkbox]');
            if (radioImageCheckboxes.length > 0) {
                productOption = [];
                var optionId = optionChanged.closest('.product-option').find('.product-option-id').val();
                optionChanged.closest('.product-option').find('.radio-image-radio:checked').each(function () {
                    productOption.push($(this).attr('name').replace('product-options[' + optionId + '][', '').replace(']', ''));
                });
            }
            var fpd_product_price = '';
            if ($('input[name=fpd_product_price]').length > 0) {
                fpd_product_price = $('input[name=fpd_product_price]').val();
            }
            var attributes = {};
            summary.find('.variations').find('input, select').each(function () {
                attributes[$(this).attr('name')] = $(this).val();
            });
            var post_id = optionChanged.closest('.product-options').find('.product-post-id').val();
            var product_option_post_id = optionChanged.closest('.product-option').find('.product-option-post-id').val();
            var product_option_id = optionChanged.closest('.product-option').find('.product-option-id').val();
            var variation_id = 0;
            if (summary.find('input[name="variation_id"]').length > 0) {
                variation_id = summary.find('input[name="variation_id"]').val();
            }
            optionChanged.find('.product-option-error').remove();
            jQuery.post(woocommerce_product_options_settings.ajaxurl,
                    {
                        'action': 'update_product_option',
                        'post_id': post_id,
                        'variation_id': variation_id,
                        'product_option_post_id': product_option_post_id,
                        'product_option': productOption,
                        'product_option_id': product_option_id,
                        'attributes': attributes,
                        fpd_product_price: fpd_product_price
                    },
            function (response) {
                response = $.parseJSON(response);
                amountToUpdate.html(response.price);
                optionPriceToUpdate.html(response.option_price);
                if (response.src != '') {
                    optionChanged.find('.upload-image').attr('src', response.src);
                }
                $('form.cart button').prop("disabled", false);
                $('form.cart button').css('opacity', '1');
                $('.product-option, .variations').find('input, select, textarea').prop("disabled", false);
                $('.product-option').find('input, select, textarea').css('opacity', '1');
				$('.variations').find('.value, .product_value, .product-value').css('opacity', '0.5');
            });
        }

        $('.product-option:not(.product-option-tooltip)').each(function () {
            var productOption = $(this);
            productOption.find('input, option, select').change(function () {
                updateMessage(productOption);
            });
            updateMessage(productOption);
        });
        $('.product-option .max-selected').each(function () {
            var maxSelected = parseInt($(this).val());
            var parent = $(this).closest('.product-option');
            parent.find('input[type=checkbox],select').change(function (event) {
                $('.max-checkboxes-error').remove();
                var numberSelected = parent.find('input[type=checkbox]:checked, option:selected').length;
                if (numberSelected > maxSelected) {
                    $(this).removeAttr('checked');
                    $(this).find('option:selected').removeAttr('selected');
                    $(this).closest('label,select').after('<span class="max-checkboxes-error product-option-error"> ' + woocommerce_product_options_settings.checkboxes_max_error + '</span>');
                    updateMessage(parent);
                    event.preventDefault();
                }
            });
        });
        
        $('.product-option-datepicker input').change(function () {

        });
        function addDatepicker(element, options) {
            var productOption = element.closest('.product-option');
            options.defaultDate = productOption.find('.date-chosen').val();
            if (productOption.find('.disallow-past').val() != '') {
                options.minDate = -1;
            }
            if (productOption.find('.disallow-today').val() != '') {
                options.minDate = 0;
            }
            if (productOption.find('.disallow-weekends').val() != '') {
                options.beforeShowDay = function (date) {
                    var day = date.getDay();
                    if (day == 0 || day == 6) {
                        return new Array(false, '', date.toLocaleDateString());
                    }
                    return new Array(true, '', date.toLocaleDateString());
                }
            }
            element.datepicker(options);
        }
        $('.product-option-input-datepicker').each(function () {
            addDatepicker($(this), {});
        });
        $('.product-option-datepicker-div').each(function () {
            var nameOfInput = $(this).find('.name-of-input').val();
            addDatepicker($(this), {altField: 'input[name="' + nameOfInput + '"]',
                onSelect: function () {
                    var productOption = $(this).closest('.product-option');
                    var nameOfInput = productOption.find('.name-of-input').val();
                    $('input[name="' + nameOfInput + '"]').change();
                }});
        });
        $('.datepicker-icon').each(function () {
            $(this).closest('.product-option').find('.product-option-datepicker-div').hide();
        });
        $('.datepicker-icon').click(function (event) {
            $(this).closest('.product-option').find('.product-option-datepicker-div').show(1000);
            $(this).hide(1000);
            event.preventDefault();
        });
        $('.datepicker-icon-value').change(function () {
            /*var productOption = $(this).closest('.product-option');
             productOption.find('.datepicker-icon').show(1000);
             productOption.find('.product-option-datepicker-div').hide(1000);*/
        });
        $('.accordion-group').click(function () {
            var productOptions = $(this).closest('.product-option-groups');
            if (productOptions.find('.accordion-keep-open').val() == '') {
                productOptions.find('.product-option-accordion-group-content').hide(500);
            }
            var thisAccordionExpand = $(this).find('.accordion-group-expand');
            if (thisAccordionExpand.text().indexOf('+') != -1) {
                $(this).closest('.product-option-group').find('.product-option-accordion-group-content').show(500);
                $(this).find('.accordion-group-expand').html('-');
            }
            if (productOptions.find('.accordion-keep-open').val() == '') {
                productOptions.find('.accordion-group-expand').html('+');
            } else {
                if (!thisExpanded) {
                    $(this).closest('.product-option').find('.product-option-accordion-group-content').hide(500);
                    $(this).find('.accordion-group-expand').html('+');
                }
            }
        });
        $('.product-option-accordion-group-content').hide(500);
        $('.accordion').click(function () {
            var productOptions = $(this).closest('.product-options');
            if (productOptions.find('.accordion-keep-open').val() == '') {
                productOptions.find('.product-option-accordion-content').hide(500);
            }
            var thisAccordionExpand = $(this).find('.accordion-expand');
            var thisExpanded = false;
            if (thisAccordionExpand.text().indexOf('+') != -1) {
                $(this).closest('.product-option').find('.product-option-accordion-content').show(500);
                thisExpanded = true;
            }
            if (productOptions.find('.accordion-keep-open').val() == '') {
                productOptions.find('.accordion-expand').html('+');
            } else {
                if (!thisExpanded) {
                    $(this).closest('.product-option').find('.product-option-accordion-content').hide(500);
                    $(this).find('.accordion-expand').html('+');
                }
            }
            if (thisExpanded) {
                $(this).find('.accordion-expand').html('-');
            }
        });
        $('.product-options').each(function () {
            if ($(this).find('.accordion').length > 0) {
                $('.product-option-accordion-content').hide();
            }
        });
        $('.number-as-text').change(function () {
            $('.number-as-text-error').remove();
            $('.number-as-text').each(function () {
                if (!$.isNumeric($(this).val())) {
                    $(this).after(woocommerce_product_options_settings.numeric_error);
                }
            });
        });

        $('.product-options').each(function () {
            $(this).find('input[type=text], textarea').keyup(function () {
                var productOption = $(this).closest('.product-option');
                var value = $(this).val();
                var numberOfLineBreaks = (value.match(/\n/g) || []).length;
                if (productOption.find('.maximum-number-of-characters').length > 0) {
                    var maximumNumberOfCharacters = parseInt(productOption.find('.maximum-number-of-characters').val());
                    var numberOfCharacters = parseInt($(this).val().length);
                    if (numberOfCharacters - numberOfLineBreaks > maximumNumberOfCharacters) {
                        $(this).val(value.substring(0, maximumNumberOfCharacters + numberOfLineBreaks));
                    }
                }
            })
        });
        $('.product-option').find('input[type=color], input[type=text], input[type=number], input[type=checkbox], input[type=radio], input[type=checkbox], select, textarea').change(function () {
            ajax_update_option($(this));
        });
        $('.product-options').closest('.summary, .main-data, li.product, .product-info').find('input[name=variation_id]').change(function () {
            if ($(this).val() != '') {
                ajax_update_option($('.product-option .product-option-content').find('input, select, textarea').first());
            }
        });
        $('input[name=fpd_product_price]').change(function () {
            ajax_update_option($('.product-option .product-option-content').find('input, select, textarea').first());
        });
        $('.product-option input[type=radio]').change(function () {
            $(this).closest('.product-option').find('.product-option-value').removeClass('product-option-value');
            $(this).addClass('product-option-value');
        });
        $('.product-option input[type=radio]:checked').addClass('product-option-value');
        $('.radio-image-radio').change(function () {
            var img = $(this).closest('.radio-image-label').find('.radio-image-image');
            if (img.hasClass('change-thumb-on-select')) {
                img.closest('.product').find('.woocommerce-main-image img, .woocommerce-main-image .wp-post-image, #product-img-slider .product-slider-image, .thb-product-slideshow rsImg').attr('src', img.attr('src'));
            }
        });


        $('.product-option-spinner').each(function () {
            $(this).spinner({
                min: 0, //$(this).attr('min'),
                max: 100, /// $(this).attr('max'),
                start: 3, //$(this).closest('.product-option').find('.product-option-value').val(),
                numberFormat: 'n',
                slide: function (event, ui) {
                    $(this).closest('.product-option').find('.product-option-value').val(ui.value);
                }
            });
        });

        $('.product-option-slider').each(function () {
            $(this).slider({range: false,
                min: $(this).attr('min'),
                max: $(this).attr('max'),
                value: $(this).closest('.product-option').find('.product-option-value').val(),
                slide: function (event, ui) {
                    $(this).closest('.product-option').find('.product-option-value').val(ui.value);
                }
            });
        });

        function updateRange(element) {
            var productOption = element.closest('.product-option');
            var unit = productOption.find('.range-unit').val();
            productOption.find('.range-value').remove();
            var productOptionValue = productOption.find('.product-option-value');
            productOption.find('.product-option-content').append('<span class="range-value"> ' + productOptionValue.val() + ' ' + unit + '</span>');
        }
        $('.product-option').find('.product-option-slider').mouseup(function () {
            ajax_update_option($(this).closest('.product-option').find('.product-option-value'));
            updateRange($(this));
        });
        $('.product-option').find('.product-option-slider').keyup(function () {
            ajax_update_option($(this).closest('.product-option').find('.product-option-value'));
            updateRange($(this));
        });
        $('.product-option .product-option-slider').each(function () {
            updateRange($(this));
        });


        function checkForErrorsBeforeCartSubmit(form) {
            $('.required-error').remove();
            var requiredErrorExists = false;
            form.find('.required-product-option').each(function () {
                if ($(this).attr('type') == 'checkbox' || $(this).attr('type') == 'radio') {
                    if ($(this).closest('div.product-option').find('input:checked').length == 0) {
                        requiredErrorExists = true;
                        if ($(this).closest('div.product-option').find('.required-error').length == 0) {
                            $(this).closest('div.product-option').find('.required-error').remove();
                            $(this).closest('div.product-option').append('<span class="required-error"> ' + woocommerce_product_options_settings.required_error + '</span>');
                        }
                    }
                } else {
                    if ($(this).val().length == 0) {
                        requiredErrorExists = true;
                        $(this).after('<span class="required-error"> ' + woocommerce_product_options_settings.required_error + '</span>');
                    }
                }
                if ($(this).attr('type') == 'checkbox' && !$(this).hasClass('checkboxes-checkbox')) {
                    if (!$(this).is(':checked')) {
                        requiredErrorExists = true;
                        $(this).after('<span class="required-error"> ' + woocommerce_product_options_settings.required_error + '</span>');
                    }
                }
            });
            form.find('.product-option .min-selected').each(function () {
                var minSelected = parseInt($(this).val());
                var parent = $(this).closest('.product-option');
                parent.find('.min-checkboxes-error').remove();
                var numberSelected = parent.find('input[type=checkbox]:checked, option:selected').length;
                if (numberSelected < minSelected) {
                    parent.find('label, select').last().after('<span class="min-checkboxes-error product-option-error"> ' + woocommerce_product_options_settings.checkboxes_min_error + '</span>');
                    requiredErrorExists = true;
                }
            });
            form.find('.product-options').find('.number-as-text, .product-option-number .product-option-value').each(function () {
                var min = $(this).attr('min');
                var max = $(this).attr('max');
                var value = $(this).val();
                if (isNaN(value)) {
                    requiredErrorExists = true;
                    $(this).after('<span class="required-error product-option-error"> ' + woocommerce_product_options_settings.number_error + '</span>');
                } else {
                    value = parseFloat(value);
                    if (typeof min != 'undefined') {
                        min = parseFloat(min);
                        if (min > value) {
                            requiredErrorExists = true;
                            $(this).after('<span class="required-error product-option-error"> ' + woocommerce_product_options_settings.min_error + min + '</span>');
                        }
                    }
                    if (typeof max != 'undefined') {
                        max = parseFloat(max);
                        if (max < value) {
                            requiredErrorExists = true;
                            $(this).after('<span class="required-error product-option-error"> ' + woocommerce_product_options_settings.max_error + max + '</span>');
                        }
                    }
                }
            });
            if (requiredErrorExists) {
                form.find('button').prop("disabled", true);
                form.find('form.cart button').css('opacity', '0.5');
                event.preventDefault();
                return false;
            }
            return true;
        }

        $('.add_to_cart_button').click(function (event) {
            var product = $(this).closest('.product');
            if (product.length == 1) {
                return checkForErrorsBeforeCartSubmit(product, event);
            }
        });
        $('form.cart').submit(function (event) {
            return checkForErrorsBeforeCartSubmit($(this).closest('.summary, .wp-content, .product, .summary, .main-data, .product-info'), event);
        });

        $(window).load(function () {
            $('.product-option').each(function () {
                $(this).find('input[type=color], input[type=text], input[type=number], input[type=radio], input[type=checkbox], select, textarea').each(function () {
                    ajax_update_option($(this));
                });
            });
        });

        $('.product-option').each(function () {
            $(this).find('input[type=color], input[type=text], input[type=number], input[type=radio]:checked, input[type=checkbox]:checked, select, textarea').each(function () {
                ajax_update_option($(this));
            });
        });

        $('.product-options .product-option-tooltip').tooltip({
            track: true
        });

//$('.radio-image-option').hide();
        $('.radio-image-label').mouseenter(function () {
// $(this).find('.radio-image-option').show(500);
        }).mouseleave(function () {
// $(this).find('.radio-image-option').hide(500);
        }).click(function () {
            if ($(this).find('input[type=radio]').length > 0) {
                $(this).find('input[type=radio]').attr('checked', 'checked');
                $(this).find('input[type=radio]').change();
                $(this).closest('.product-option').find('.selected-radio-image')
                        .removeClass('selected-radio-image');
                $(this).addClass('selected-radio-image');
            } else {
                var checkbox = $(this).find('input[type=checkbox]');
                if (checkbox.attr('checked') == 'checked') {
                    checkbox.removeAttr('checked');
                } else {
                    checkbox.attr('checked', 'checked');
                }
                checkbox.change();
                var productOption = $(this).closest('.product-option');
                if(productOption.find('.product-option-error').length>0) {
                    return;
                }
                ajax_update_option($(this));
                productOption.find('.selected-radio-image').removeClass('selected-radio-image');
                productOption.find('input[type=checkbox]:checked').closest('.radio-image-label').addClass('selected-radio-image');
            }
        });

    }
});