<?php

$product_option_product_id = 0;

class Woocommerce_Product_Options_Product_Frontend {

    //Creates object
    function __construct() {
        //The content of the post
        $settings = get_option( 'woocommerce_product_options_settings', array() );
        if ( !empty( $settings['position'] ) ) {
            add_action( 'woocommerce_single_product_summary', array( $this, 'print_options' ), $settings['position'], 0 );
			add_action( 'woocommerce_single_product_summary', array( $this, 'print_group_options' ), $settings['position'], 0 );
        } else {
            add_action( 'woocommerce_single_product_summary', array( $this, 'woocommerce_single_product_summary_end' ), 60, 0 );
            add_action( 'woocommerce_single_product_summary', array( $this, 'woocommerce_single_product_summary_before_add_to_cart' ), 25, 0 );
            add_action( 'woocommerce_before_single_product_summary', array( $this, 'move_price_above_add_to_cart' ) );
        }
        add_action( 'woocommerce_after_shop_loop_item', array( $this, 'woocommerce_after_shop_loop_item' ), 10, 0 );
        add_action( 'init', array( $this, 'add_shortcodes' ) );
    }
	
	function print_group_options() {
		$settings = get_post_meta( $post_id, 'product-options-settings', true );
		if ( !empty( $settings['position'] ) ) {
            global $woocommerce_product_options_product_option_group;
            $woocommerce_product_options_product_option_group->print_options( false );
        }
	}

    /**
     * Ajax that shows frontend product option for backend preview
     */
    function ajax_get_product_option_preview() {
        if ( empty( $_POST['options_chosen'] ) ) {
            die();
        }
        $options_chosen = ( array ) $_POST['options_chosen'];
        $this->_print_options( $options_chosen, 0, 0 );
        die();
    }

    /**
     * To show the options on the shop and search pages
     */
    function woocommerce_after_shop_loop_item() {
        global $post;
        $post_id = $post->ID;
        $settings = get_post_meta( $post_id, 'product-options-settings', true );
        $show_in_list = value( $settings, 'show_in_list', '' );
        if ( !empty( $show_in_list ) ) {
            $this->print_options();
            global $woocommerce_product_options_product_option_group;
            $woocommerce_product_options_product_option_group->print_options( false );
        }
    }

    function add_shortcodes() {
        add_shortcode( 'productoptions', array( $this, 'print_options' ) );
    }

    function move_price_above_add_to_cart() {
        global $post;
        $settings = get_post_meta( $post->ID, 'product-options-settings', true );
        $above_add_to_cart = value( $settings, 'above_add_to_cart', '' );
        if ( !empty( $above_add_to_cart ) && has_action( 'woocommerce_single_product_summary', 'woocommerce_template_single_price' ) === 10 ) {
            remove_action( 'woocommerce_single_product_summary', 'woocommerce_template_single_price', 10 );
            add_action( 'woocommerce_single_product_summary', 'woocommerce_template_single_price', 27 );
        }
    }

    /**
     * Displays options after summary
     */
    function woocommerce_single_product_summary_before_add_to_cart() {
        global $post;
        $settings = get_post_meta( $post->ID, 'product-options-settings', true );
        $above_add_to_cart = value( $settings, 'above_add_to_cart', '' );
        if ( !empty( $above_add_to_cart ) ) {
            $this->print_options( 'above_add_to_cart' );
        }
        $settings = get_option( 'woocommerce_product_options_settings', array() );
        if ( empty( $settings['position'] ) ) {
            global $woocommerce_product_options_product_option_group;
            $woocommerce_product_options_product_option_group->print_options( 'above_add_to_cart' );
        }
    }

    /**
     * Displays options after summary
     */
    function woocommerce_single_product_summary_end() {
        global $post;
        $settings = get_post_meta( $post->ID, 'product-options-settings', true );
        $above_add_to_cart = value( $settings, 'above_add_to_cart', '' );
        if ( empty( $above_add_to_cart ) ) {
            $this->print_options( 'below_add_to_cart' );
        }
        $settings = get_option( 'woocommerce_product_options_settings', array() );
        if ( empty( $settings['position'] ) ) {
            global $woocommerce_product_options_product_option_group;
            $woocommerce_product_options_product_option_group->print_options( 'below_add_to_cart' );
        }
    }

    /**
     * Displays options
     */
    function print_options( $position = false ) {
        global $post;
        $post_id = $post->ID;
        $options = get_post_meta( $post_id, 'backend-product-options' );
        if ( isset( $options[0] ) && !isset( $options[0]['type'] ) ) {
            $options = $options[0];
        }
        $this->_print_options( $options, $post_id, $post_id );
		$settings = get_option( 'woocommerce_product_options_settings', array() );
    }

    /**
     * Displays options
     */
    function _print_options( $options, $product_option_post_id, $post_id ) {
        global $product_option_product_id;
        $product_option_product_id = $post_id;
        $product_meta_settings = get_post_meta( $product_option_post_id, 'product-options-settings', true );
        print '<div class="product-options">
		<input type="hidden" class="product-post-id" value="' . $post_id . '" />
				<script>
function updateFrameSize(pixels, id){
    pixels+=12;
    document.getElementById(id).style.height=pixels+"px";
}
</script>';
        print '<input type="hidden" value="' . value( $product_meta_settings, 'accordion_keep_open' ) . '" class="accordion-keep-open" />';
        print '<input type="hidden" value="' . value( $product_meta_settings, 'accordion_keep_open_on_select' ) . '" class="accordion-keep-open-on-select" />';
        if ( !empty( $options ) ) {
            foreach ( $options as $option_id => $option ) {
                $value_chosen = value( $option, 'default', '' );
                $no_default = value( $option, 'no_default', '' );
                if ( !empty( $no_default ) ) {
                    $value_chosen = '';
                }
                if ( isset( $_SESSION['product_options_' . $product_option_post_id . '_' . $option_id] ) ) {
                    $value_chosen = $_SESSION['product_options_' . $product_option_post_id . '_' . $option_id];
                }
                $name = 'product-options[' . $option_id . ']';
                $type = value( $option, 'type', '' );
                if ( !empty( $option['show-price'] ) ) {
                    global $woocommerce_product_options_ajax;
                    $option['current-price'] = $woocommerce_product_options_ajax->get_option_price( $post_id, $product_option_post_id, $option_id, $option );
                }
                $this->before_input( $option_id, $name, $option, $product_option_post_id );
                if ( $type == 'radio' ) {
                    $this->radio_input( $name, $option, $value_chosen );
                } elseif ( $type == 'checkboxes' ) {
                    $this->checkboxes_input( $name, $option, $value_chosen );
                } elseif ( $type == 'image_upload' ) {
                    $this->image_upload_input( $name, $option, $value_chosen, $option_id, $product_option_post_id );
                } elseif ( $type == 'radio_image' ) {
                    $this->radio_image_input( $name, $option, $value_chosen );
                } elseif ( $type == 'select' ) {
                    $this->select_input( $name, $option, $value_chosen );
                } elseif ( $type == 'multi_select' ) {
                    $this->multi_select_input( $name, $option, $value_chosen );
                } elseif ( $type == 'color_picker' ) {
                    $this->color_picker( $name, $option, $value_chosen );
                } elseif ( $type == 'number' || $type == 'range' || $type == 'number_as_text' ) {
                    $this->numeric_input( $name, $option, $value_chosen );
                } elseif ( $type == 'checkbox' ) {
                    $this->checkbox_input( $name, $option, $value_chosen );
                } elseif ( $type == 'text' ) {
                    $this->text_input( $name, $option, $value_chosen );
                } elseif ( $type == 'textarea' ) {
                    $this->textarea_input( $name, $option, $value_chosen );
                } elseif ( $type == 'datepicker' ) {
                    $this->datepicker_input( $name, $option, $value_chosen );
                }
                $this->after_input( $option_id, $name, $option );
            }
        }
        print '</div>';
    }

    /**
     * Before the option
     */
    function before_input( $option_id, $name, $option, $product_option_post_id ) {
        global $post;
        if ( !empty( $post ) ) {
            $post_id = $post->ID;
        } else {
            $post_id = 0;
        }
        $type = value( $option, 'type', '' );
        $tooltip = value( $option, 'tooltip', '' );
        $tooltip_class = '';
        if ( !empty( $tooltip ) ) {
            $tooltip_class = 'product-option-tooltip';
        }
        print '<div class="product-option product-option-' . $type . ' ' . $tooltip_class . '">';
        print '<input type="hidden" class="product-option-post-id" value="' . $product_option_post_id . '" />';
        print '<input type="hidden" class="product-option-id" value="' . $option_id . '" />';
        if ( !empty( $option['maximum_number_of_characters'] ) ) {
            $maximum_number_of_characters = value( $option, 'maximum_number_of_characters', 0 );
            print '<input type="hidden" class="maximum-number-of-characters" value="' . $maximum_number_of_characters . '" />';
        }
        $title = value( $option, 'title', '' );
        $label = value( $option, 'label-before', '' );
        $show_price = value( $option, 'show-price', '' );
        $settings = get_post_meta( $post_id, 'product-options-settings', true );
        $accordion = value( $settings, 'accordion', value( $option, 'accordion' ) );
        $price = value( $option, 'price', '' );
        $required = value( $option, 'required', false );
        if ( !empty( $show_price ) && !empty( $price ) ) {
            $label = $label . ' ' . woocommerce_price( value( $option, 'price', '' ) );
        }
        if ( !empty( $title ) ) {
            $title_classes = 'product-option-title';
            if ( !empty( $accordion ) ) {
                $title_classes.=' accordion';
            }
            print '<h3 class=" ' . $title_classes . '">';
            if ( !empty( $accordion ) ) {
                print '<span class="accordion-expand">+</span> ';
            }
            print $title;
            if ( !empty( $option['show-price'] ) ) {
                print ' (<span class="current-price">' . woocommerce_price( $option['current-price'] ) . '</span>) ';
            }
            if ( $required ) {
                print ' *';
            }
            print '</h3>';
        }
        print '<div class="product-option-content';
        if ( !empty( $accordion ) ) {
            print ' product-option-accordion-content';
        }
        print '">';
        if ( !empty( $label ) ) {
            print '<p class="product-option-label">' . $label . '</p>';
        }
    }

    /**
     * After the option
     */
    function after_input( $option_id, $name, $option ) {
        $label = value( $option, 'label-after', '' );
        print ' <span class="product-option-label-after">' . $label . '</span>';
        print '</div></div>';
    }

    /**
     * Displays numeric option
     */
    function numeric_input( $name, $option, $value_chosen ) {
        $display = value( $option, 'type', 'number' );
        $minimum = value( $option, 'minimum', '' );
        $maximum = value( $option, 'maximum', '' );
        $step_size = value( $option, 'step-size', '0.01' );
        $required = value( $option, 'required', false );
        $required_class = '';
        if ( $required ) {
            $required_class = ' required-product-option';
        }
        if ( empty( $value_chosen ) && !empty( $minimum ) ) {
            $value_chosen = $minimum;
        } elseif ( empty( $value_chosen ) ) {
            $value_chosen = 0;
        }
        $min = '';
        $max = '';
        if ( !empty( $minimum ) ) {
            $min = 'min="' . $minimum . '"';
        }
        if ( !empty( $maximum ) ) {
            $max = 'max="' . $maximum . '"';
        }
        if ( $display == 'number' ) {
            print '<input step="' . $step_size . '"  class="product-option-value' . $required_class . '" type="number" name="' . $name . '" ' . $min . ' ' . $max . ' value="' . $value_chosen . '" />';
            //print '<div class="product-option-spinner" ' . $min . $max . ' step="' . $step_size . '"></div>';
        } elseif ( $display == 'range' ) {
            print sprintf( __( '(%d - %d)', 'woocommerce-product-options' ), $minimum, $maximum );
            print '<input type="hidden" class="range-unit' . $required_class . '" value="' . value( $option, 'label-after', '' ) . '"/>' .
                    ' <input class="product-option-value" type="hidden" step="' . $step_size . '" name="' . $name . '" ' . $min . ' ' . $max . ' value="' . $value_chosen . '" />';
            print '<div class="product-option-slider" ' . $min . $max . ' step="' . $step_size . '"></div>' . value( $option, 'label-after', '' );
        } elseif ( $display == 'number_as_text' ) {
            print '<input type="text" class="number-as-text product-option-value' . $required_class . '" name="' . $name . '" ' . $min . ' ' . $max . ' value="' . $value_chosen . '" />';
        }
    }

    /**
     * Displays select option
     */
    function select_input( $name, $product_option, $value_chosen ) {
        $options = value( $product_option, 'options', array() );
        $show_option_prices = value( $product_option, 'show-option-prices', '' );
        $no_default = value( $product_option, 'no_default', '' );
        if ( !empty( $no_default ) ) {
            $options = array_merge( array( '' => '' ), $options );
        }
        $required = value( $product_option, 'required' );
        $required_class = '';
        if ( !empty( $required ) ) {
            $required_class = ' required-product-option';
        }
        print '<select class="product-option-value ' . $required_class . '" name="' . $name . '">';
        if ( !empty( $options ) ) {
            foreach ( $options as $option_id => $option ) {
                $label = value( $option, 'label', '' );
                if ( !empty( $show_option_prices ) ) {
                    $option_price = 0;
                    if ( !empty( $option['price'] ) ) {
                        $option_price += floatval( $option['price'] );
                    }
                    if ( !empty( $option['percentage_price'] ) ) {
                        global $product_option_product_id;
                        $product = get_product( $product_option_product_id );
                        $product_price = floatval( $product->get_price() );
                        $option_price += $product_price * floatval( $option['percentage_price'] ) / 100;
                    }
                    $label = $label . ' (' . woocommerce_price( $option_price ) . ')';
                }
                print '<option value="' . $option_id . '" ';
                if ( strval( $value_chosen ) == strval( $option_id ) ) {
                    print 'selected';
                }
                print ' title="' . $this->get_message( $product_option, $option, $option_id, true ) . '" >' . $label . '</option>' . $this->get_message( $product_option, $option, $option_id );
            }
        }
        print '</select>';
    }

    function color_picker( $name, $product_option, $value_chosen ) {
        print '<input type="color" class="product-option-value product-options-color-picker" name="' . $name . '" value=' . $value_chosen . ' />';
    }

    /**
     * Displays multi-select option
     */
    function multi_select_input( $name, $product_option, $value_chosen ) {
        if ( is_string( $value_chosen ) ) {
            $value_chosen = array( $value_chosen );
        }
        $this->max_and_min_selected( $product_option );
        $options = value( $product_option, 'options', array() );
        $show_option_prices = value( $product_option, 'show-option-prices', '' );
        $no_default = value( $product_option, 'no_default', '' );
        if ( !empty( $no_default ) ) {
            $options = array_merge( array( '' => '' ), $options );
        }
        $required = value( $product_option, 'required' );
        $required_class = '';
        if ( !empty( $required ) ) {
            $required_class = ' required-product-option';
        }
        print '<select class="product-option-value' . $required_class . '" name="' . $name . '[]" multiple>';
        if ( !empty( $options ) ) {
            foreach ( $options as $option_id => $option ) {
                $label = value( $option, 'label', '' );
                if ( !empty( $show_option_prices ) ) {
                    $option_price = 0;
                    if ( !empty( $option['price'] ) ) {
                        $option_price += floatval( $option['price'] );
                    }
                    if ( !empty( $option['percentage_price'] ) ) {
                        global $product_option_product_id;
                        $product = get_product( $product_option_product_id );
                        $product_price = floatval( $product->get_price() );
                        $option_price += $product_price * floatval( $option['percentage_price'] ) / 100;
                    }
                    $label = $label . ' (' . woocommerce_price( $option_price ) . ')';
                }
                print '<option value="' . $option_id . '" ';
                if ( in_array( $option_id, $value_chosen ) ) {
                    print 'selected';
                }
                print ' title="' . $this->get_message( $product_option, $option, $option_id, true ) . '" >' . $label . '</option>' . $this->get_message( $product_option, $option, $option_id );
            }
        }
        print '</select>';
    }

    /**
     * Displays image options
     */
    function radio_image_input( $name, $product_option, $value_chosen ) {
        $options = value( $product_option, 'options', array() );
        $show_option_prices = value( $product_option, 'show-option-prices', '' );
        $change_thumb_on_select = value( $product_option, 'change-thumb-on-select', '' );
        $multiple = value( $product_option, 'multiple', '' );
        $array_of_values = $value_chosen;
        if ( is_string( $array_of_values ) ) {
            $array_of_values = array( $array_of_values );
        }
        $this->max_and_min_selected( $product_option );
        if ( !empty( $options ) ) {
            foreach ( $options as $option_id => $option ) {
                $label = value( $option, 'label', '' );
                if ( !empty( $show_option_prices ) ) {
                    $option_price = 0;
                    if ( !empty( $option['price'] ) ) {
                        $option_price += floatval( $option['price'] );
                    }
                    if ( !empty( $option['percentage_price'] ) ) {
                        global $post_id;
                        $product = get_product( $post_id );
                        $product_price = floatval( $product->get_price() );
                        $option_price += $product_price * floatval( $option['percentage_price'] ) / 100;
                    }
                    $label = $label . ' (' . woocommerce_price( $option_price ) . ')';
                }
                $src = value( $option, 'src', '' );
                if ( !empty( $src ) ) {
                    print '<label class="radio-image-label';
                    if ( in_array( $option_id, $array_of_values ) ) {
                        print ' selected-radio-image';
                    }
                    print '" for="' . $name . '" title="' . $this->get_message( $product_option, $option, $option_id, true ) . '" >' .
                            '<img src="' . $src . '" class="radio-image-image';
                    if ( !empty( $change_thumb_on_select ) ) {
                        print ' change-thumb-on-select';
                    }
                    print '" />' . '<br><span class="radio-image-option">' . $label . '</span>';
                    print '<input class="radio-image-radio" type="';
                    if ( empty( $multiple ) ) {
                        print 'radio';
                    } else {
                        print 'checkbox';
                    }
                    print '" name="' . $name;
                    if ( !empty( $multiple ) ) {
                        print '[' . $option_id . ']';
                    }
                    print '" value="' . $option_id . '" ';
                    if ( empty( $multiple ) ) {
                        if ( strval( $value_chosen ) == strval( $option_id ) ) {
                            print 'checked="checked"';
                        }
                    } else {
                        if ( in_array( $option_id, $array_of_values ) ) {
                            print 'checked="checked"';
                        }
                    }
                    print ' />' . $this->get_message( $product_option, $option ) . '</label>';
                }
            }
        }
    }

    function max_and_min_selected( $product_option ) {
        $max_selected = value( $product_option, 'max_selected' );
        if ( !empty( $max_selected ) ) {
            print '<input type="hidden" class="max-selected" value="' . $max_selected . '"/>';
        }
        $min_selected = value( $product_option, 'min_selected' );
        if ( !empty( $min_selected ) ) {
            print '<input type="hidden" class="min-selected" value="' . $min_selected . '"/>';
        }
    }

    /**
     * Displays checkboxes option
     */
    function checkboxes_input( $name, $product_option, $value_chosen ) {
        $required = value( $product_option, 'required', false );
        $required_class = '';
        if ( $required ) {
            $required_class = ' required-product-option';
        }
        $options = value( $product_option, 'options', array() );
        if ( is_string( $value_chosen ) ) {
            $value_chosen = array( $value_chosen );
        }
        $this->max_and_min_selected( $product_option );
        $show_option_prices = value( $product_option, 'show-option-prices', '' );
        if ( !empty( $options ) ) {
            foreach ( $options as $option_id => $option ) {
                $label = value( $option, 'label', '' );
                if ( !empty( $show_option_prices ) ) {
                    $option_price = 0;
                    if ( !empty( $option['price'] ) ) {
                        $option_price += floatval( $option['price'] );
                    }
                    if ( !empty( $option['percentage_price'] ) ) {
                        global $product_option_product_id;
                        $product = get_product( $product_option_product_id );
                        $product_price = floatval( $product->get_price() );
                        $option_price += $product_price * floatval( $option['percentage_price'] ) / 100;
                    }
                    $label = $label . ' (' . woocommerce_price( $option_price ) . ')';
                }
                print '<label for="' . $name . '" title="' . $this->get_message( $product_option, $option, $option_id, true ) . '"> ';
                print '<input type="checkbox" name="' . $name . '[' . $option_id . ']" class="checkboxes-checkbox ' . $required_class . '" value="' . $option_id . '" ';
                if ( in_array( $option_id, $value_chosen ) ) {
                    print 'checked="checked"';
                }
                print ' /> ';
                print $label . $this->get_message( $product_option, $option ) . '</label>';
                print '<br>';
            }
        }
    }

    function get_message( $product_option, $option, $option_id = -1, $without_span = false ) {
        $tooltip = value( $product_option, 'tooltip' );
        if ( !empty( $tooltip ) && !$without_span ) {
            return '';
        }
        $message = value( $option, 'message' );
        if ( !empty( $message ) ) {
            $src = value( $option, 'src' );
            $image = '';
            if ( !empty( $src ) ) {
                $image = '<img src="' . $src . '" />';
            }
            if ( $without_span ) {
                return str_replace( '"', '\"', $message );
            }
            return '<span class="product-option-message product-option-message-' . $option_id . '">' . $image . $message . '</span>';
        }
        return '';
    }

    /**
     * Displays radio buttons option
     */
    function radio_input( $name, $product_option, $value_chosen ) {
        $options = value( $product_option, 'options', array() );
        $show_option_prices = value( $product_option, 'show-option-prices', '' );
        if ( !empty( $options ) ) {
            foreach ( $options as $option_id => $option ) {
                $label = value( $option, 'label', '' );
                if ( !empty( $show_option_prices ) ) {
                    $option_price = 0;
                    if ( !empty( $option['price'] ) ) {
                        $option_price += floatval( $option['price'] );
                    }
                    if ( !empty( $option['percentage_price'] ) ) {
                        global $product_option_product_id;
                        $product = get_product( $product_option_product_id );
                        $product_price = floatval( $product->get_price() );
                        $option_price += $product_price * floatval( $option['percentage_price'] ) / 100;
                    }
                    $label = $label . ' (' . woocommerce_price( $option_price ) . ')';
                }
                print '<label title="' . $this->get_message( $product_option, $option, $option_id, true ) . '">' . $label;
                print '<input type="radio" name="' . $name . '" value="' . $option_id . '" ';
                if ( strval( $value_chosen ) == strval( $option_id ) ) {
                    print 'checked="checked"';
                }
                print ' />';
                print $this->get_message( $product_option, $option ) . '</label>';
            }
        }
    }

    function image_upload_input( $name, $option, $value_chosen, $option_id, $post_id ) {
        $change_thumb = value( $option, 'change_thumb' );
        if ( !empty( $change_thumb ) ) {
            print '<input type="hidden" class="change-thumb" value="' . $change_thumb . '" />';
        }
        print '<input type="hidden" name="' . $name . '" value="' . $value_chosen . '" />'
                . '<iframe id="iframe-' . $option_id . '" style="width:90%;border:none;" scrolling="no" src="' . WP_PLUGIN_URL . '/woocommerce-product-options/includes/image-upload.php?post-id=' . $post_id . '&option-id=' . $option_id . '"></iframe><br>';
    }

    /**
     * Displays text option
     */
    function text_input( $name, $option, $value_chosen ) {
        $required = value( $option, 'required', false );
        $required_class = '';
        if ( $required ) {
            $required_class = ' required-product-option';
        }
        print '<input class="product-option-value' . $required_class . '" type="text" name="' . $name . '" value="' . $value_chosen . '" />';
    }

    /**
     * Displays textarea option
     */
    function textarea_input( $name, $option, $value_chosen ) {
        $required = value( $option, 'required', false );
        $required_class = '';
        if ( $required ) {
            $required_class = ' required-product-option';
        }
        print '<textarea class="product-option-value' . $required_class . '" name="' . $name . '">' . $value_chosen . '</textarea>';
    }

    /**
     * Displays textarea option
     */
    function datepicker_input( $name, $option, $value_chosen ) {
        $display = value( $option, 'display' );
        if ( strpos( $value_chosen, '/' ) === false ) {
            $value_chosen = date( 'm/d/y', strtotime( value( $option, 'default' ) ) );
        }
        if ( $display == 'input' ) {
            print '<input type="text" class="product-option-input-datepicker" name="' . $name . '" value="' . $value_chosen . '" />';
        } elseif ( $display == 'inline' ) {
            print '<div class="product-option-datepicker-div"><input type="hidden" class="name-of-input" value="' . $name . '" /></div><input type="text" name="' . $name . '" value="' . $value_chosen . '" class="datepicker-value" />';
        } else {
            print '<a class="datepicker-icon"><img  src="' . WP_PLUGIN_URL . '/woocommerce-product-options/assets/images/datepicker-icon.png" /></a>'
                    . '<div class="product-option-datepicker-div"><input type="hidden" class="name-of-input" value="' . $name . '" /></div><input type="text" name="' . $name . '" value="' . $value_chosen . '" class="datepicker-value datepicker-icon-value" />';
        }
        print '<input type="hidden" class="date-chosen" value="' . $value_chosen . '" />';
        print '<input type="hidden" class="disallow-past" value="' . value( $option, 'disallow_past' ) . '" />';
        print '<input type="hidden" class="disallow-today" value="' . value( $option, 'disallow_today' ) . '" />';
        print '<input type="hidden" class="disallow-weekends" value="' . value( $option, 'disallow_weekends' ) . '" />';
        wp_enqueue_style( 'jquery-ui-datepicker-css', WP_PLUGIN_URL . '/woocommerce-product-options/assets/css/jquery-ui.css' );
    }

    /**
     * Displays checkbox option
     */
    function checkbox_input( $name, $option, $value_chosen ) {
        $required = value( $option, 'required', false );
        $required_class = '';
        if ( $required ) {
            $required_class = ' required-product-option';
        }
        print '<input class="product-option-value product-option-checkbox ' . $required_class . '" type="checkbox" name="' . $name . '" value="yes" ';
        if ( $value_chosen == 'yes' ) {
            print ' checked="checked" ';
        }
        print '/>';
    }

}

$woocommerce_product_options_product_frontend = new Woocommerce_Product_Options_Product_Frontend();
?>