<?php

class Woocommerce_Product_Options_Settings {

    function __construct() {
        add_action( 'admin_menu', array( $this, 'admin_menu' ) );
    }

    function admin_menu() {
        if ( is_admin() ) {
            add_submenu_page( 'woocommerce', __( 'Product Option Settings', 'woocommerce-product-options' ), __( 'Product Option Settings', 'woocommerce-product-options' ), 'manage_woocommerce', 'woocommerce-product-options-settings', array( $this, 'settings_page' ) );
        }
    }

    function settings_page() {
        $settings = get_option( 'woocommerce_product_options_settings', array() );
        ?>
        <h1><?php _e( 'Product Option Settings', 'woocommerce-product-options' ); ?></h1>
        <form method="post" action="options.php">
            <label>
        <?php
        _e( 'Enter a number to override the position of the options in your product summary (a value from 1 to about 70 which moves the options from the beginning to the end of the product summary)', 'woocommerce-product-options' );
        ?>
                <br>
                <input type="number" name="woocommerce_product_options_settings[position]" value="<?php
                print value( $settings, 'position' );
                ?>" />
            </label>
        <?php
        wp_nonce_field( 'update-options' );
        submit_button();
        ?>
            <input type="hidden" name="page_options" value="woocommerce_product_options_settings" />
            <input type="hidden" name="action" value="update" />
        </form>
            <?php
        }

    }

    $woocommerce_product_options_settings = new Woocommerce_Product_Options_Settings();
    ?>