<?php
    ob_start();
    register_nav_menu('left-menu', 'Left Menu');
    register_nav_menu('sticky-menu', 'Sticky Menu');


    // Ensure cart contents update when products are added to the cart via AJAX (place the following in functions.php)
    add_filter( 'woocommerce_add_to_cart_fragments', 'woocommerce_header_add_to_cart_fragment' );
    function woocommerce_header_add_to_cart_fragment( $fragments ) {
        ob_start();
    ?>
    <a class="cart-contents" href="<?php echo WC()->cart->get_cart_url(); ?>" title="<?php _e( 'View your shopping cart' ); ?>"><?php echo sprintf (_n( '%d item', '%d items', WC()->cart->cart_contents_count ), WC()->cart->cart_contents_count ); ?> - <?php echo WC()->cart->get_cart_total(); ?></a> 
    <?php

        $fragments['a.cart-contents'] = ob_get_clean();

        return $fragments;
    }


    add_action("wp_ajax_notifyme", "notifyme");
    add_action("wp_ajax_nopriv_notifyme", "notifyme");

    function notifyme(){ 
        $myname = $_POST['myname'];

        $STORE_MODE = "mailchimp";

        // MailChimp API Key findable in your Mailchimp's dashboard
        $API_KEY =  "8fd23af24e63102b801ff1d5a85342d1-us11";

        // MailChimp List ID  findable in your Mailchimp's dashboard
        $LIST_ID =  "967100271d";

        // After $_SERVER["DOCUMENT_ROOT"]." , write the path to your .txt to save the emails of the subscribers
        $STORE_FILE = $_SERVER["DOCUMENT_ROOT"]."/subscription-list.txt";

        /* ************************************ */
        // Don't forget to check the path below
        /* ************************************ */

        require('MailChimp.php');
        /* ***************************************************** */
        // For the part below, no interventions are required
        /* ***************************************************** */

        if($_SERVER["REQUEST_METHOD"] == "POST" && !empty($_POST["email"])) {

            $email = $_POST["email"];

            header('HTTP/1.1 200 OK');
            header('Status: 200 OK');
            header('Content-type: application/json');

            // Checking if the email writing is good
            if(filter_var($email, FILTER_VALIDATE_EMAIL)) {

                // The part for the storage in a .txt
                if ($STORE_MODE == "file") {

                    // SUCCESS SENDING
                    if(@file_put_contents($STORE_FILE, strtolower($email)."\r\n", FILE_APPEND)) {
                        echo json_encode(array(
                            "status" => "success"
                        ));
                        // ERROR SENDING
                    } else {
                        echo json_encode(array(
                            "status" => "error",
                            "type" => "FileAccessError"
                        ));
                    }

                    // The part for the storage in Mailchimp
                } elseif ($STORE_MODE == "mailchimp") {

                    $MailChimp = new \Drewm\MailChimp($API_KEY);

                    $result = $MailChimp->call('lists/subscribe', array(
                        'id'                => $LIST_ID,
                        'email'             => array('email'=>$email),
                        'double_optin'      => false,
                        'update_existing'   => true,
                        'replace_interests' => false,
                        'send_welcome'      => true,
                    ));     

                    // SUCCESS SENDING
                    if($result["email"] == $email) {         
                        echo json_encode(array(
                            "status" => "success"
                        ));
                        // ERROR SENDING
                    } else {
                        echo json_encode(array(
                            "status" => "error",
                            "type" => $result["name"]
                        ));
                    }
                    // ERROR
                } else {
                    echo json_encode(array(
                        "status" => "error",
                    ));
                }
                // ERROR DURING THE VALIDATION 
            } else {
                echo json_encode(array(
                    "status" => "error",
                    "type" => "ValidationError"
                ));
            }
        } else {
            header('HTTP/1.1 403 Forbidden');
            header('Status: 403 Forbidden');
        }
    }

    add_action('wp_head', 'myplugin_ajaxurl');

    function myplugin_ajaxurl() {

        echo '<script type="text/javascript">
        var ajaxurl = "' . admin_url('admin-ajax.php') . '";
        </script>';
    }


?>