<!doctype html>
<html>
<head>
    <meta charset="utf-8">
    <meta name="description" content="">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title><?php
        /*
        * Print the <title> tag based on what is being viewed.
        */
        global $page, $paged;
        wp_title( '|', true, 'right' );
        // Add the blog name.
        bloginfo( 'name' );
        // Add the blog description for the home/front page.
        $site_description = get_bloginfo( 'description', 'display' );
        if ( $site_description && ( is_home() || is_front_page() ) )
            echo " | $site_description";
        // Add a page number if necessary:
        if ( $paged >= 2 || $page >= 2 )
            echo ' | ' . sprintf( __( 'Page %s', 'twentyeleven' ), max( $paged, $page ) );
    ?></title>
    <link rel="stylesheet" href="<?=bloginfo('template_url')?>/homepage/css/bootstrap.min.css">
    <link rel="stylesheet" href="<?=bloginfo('template_url')?>/homepage/css/bootstrap-theme.min.css">
    <link rel="stylesheet" href="<?=bloginfo('template_url')?>/homepage/css/font-awesome.css">
    <link rel="stylesheet" href="<?=bloginfo('stylesheet_url')?>">
    <?php  wp_head(); ?>
</head>
<body <?php echo body_class(); ?>>
<div >
    <div class="container">
        <div class="row">
            <div class="col-md-4 logo">
                <a href="<?=site_url()?>"><img src="<?=bloginfo('template_url')?>/homepage/images/logo2.png" alt=""></a>
            </div>
            <div class="col-md-8 menu_section">
                <div class="top_menu">
                    <ul>
                        <li><a href="<?=site_url()?>/my-account/">Signup</a></li>
                        <li><a href="<?=site_url()?>/my-account/">Login</a></li>
                    </ul>
                </div>
                <div class="mainmenu">
                    <ul>
                        <li><a href="<?=site_url()?>//product-category/water-testing/">Water Testing</a></li>
                        <li><a href="">Other Products</a></li>
                        <a class="btn btn-primary" href="<?php echo WC()->cart->get_cart_url(); ?>" title="<?php _e( 'View your shopping cart' ); ?>"><?php echo sprintf (_n( '%d item', '%d items', WC()->cart->cart_contents_count ), WC()->cart->cart_contents_count ); ?> - <?php echo WC()->cart->get_cart_total(); ?></a>
                    </ul>
                </div>
            </div>
        </div>
    </div>
</div>